import static org.hamcrest.CoreMatchers.is;
import static org.junit.Assert.assertThat;

import java.util.Arrays;
import java.util.Collections;
import java.util.Comparator;
import java.util.List;

import org.junit.Test;


public class LambdaTest {
    private List<Integer> input = Arrays.asList(2, 4, 6, 8, 10, 1, 3, 5, 7, 9);

    @Test
    public void lambda100() {
        //Collections.reverse(input);
        Comparator<Integer> comparator = new Comparator<Integer>() {
            @Override
            public int compare(Integer a, Integer b) {
                return b.compareTo(a);
            }
        };
        Collections.sort(input, comparator);
        assertThat(input, is(Arrays.asList(10, 9, 8, 7, 6, 5, 4, 3, 2, 1)));
    }

    @Test
    public void lambda101() {
        Comparator<Integer> comparator = (Integer a, Integer b) -> {
            return b.compareTo(a);
        };
        Collections.sort(input, comparator);
        assertThat(input, is(Arrays.asList(10, 9, 8, 7, 6, 5, 4, 3, 2, 1)));
    }

    @Test
    public void lambda102() {
        Comparator<Integer> comparator = (a, b) -> {
            return b.compareTo(a);
        };
        Collections.sort(input, comparator);
        assertThat(input, is(Arrays.asList(10, 9, 8, 7, 6, 5, 4, 3, 2, 1)));
    }

    @Test
    public void lambda103() {
        Comparator<Integer> comparator = (a, b) -> b.compareTo(a);
        Collections.sort(input, comparator);
        assertThat(input, is(Arrays.asList(10, 9, 8, 7, 6, 5, 4, 3, 2, 1)));
    }

    @Test
    public void lambda104() {
        Collections.sort(input, (a, b) -> b.compareTo(a));
        assertThat(input, is(Arrays.asList(10, 9, 8, 7, 6, 5, 4, 3, 2, 1)));
    }

    @Test
    public void lambda201() {
        new Thread(() -> System.out.println("Test")).start();
    }

    @Test
    public void lambda301() {
        Collections.sort(input, Comparator.<Integer> naturalOrder());
        assertThat(input, is(Arrays.asList(1, 2, 3, 4, 5, 6, 7, 8, 9, 10)));
    }

    @Test
    public void lambda302() {
        Collections.sort(input, Comparator.<Integer> naturalOrder().reversed());
        assertThat(input, is(Arrays.asList(10, 9, 8, 7, 6, 5, 4, 3, 2, 1)));
    }

}
